#version 330

uniform vec3 cameraPos;
uniform vec3 spotPos;
uniform float dmax;

in vec4 vWorldPos;
in vec4 vColor;
in vec3 vNormal;

out vec4 fColor;

vec3 calcNormal(){
	vec3 tempNormal = vNormal;
	
	return normalize(tempNormal);
}

void main() {
	vec3 N = calcNormal();
	vec3 V = normalize(cameraPos - vWorldPos.xyz); 

	float d = abs(length(vWorldPos.xyz - spotPos.xyz));
	float I = 1 - (d/dmax);//* dot(V,N);

	fColor = vec4(1.0,1.0,1.0,0.1)* I;
}