#version 330

uniform mat4 modelMatrix;
uniform mat4 VP;
uniform mat4 LVP;

uniform bool hasNormalMap;
uniform bool hasShadowMap;


layout(location = 0) in vec3 pos;
layout(location = 1) in vec3 color;
layout(location = 2) in vec3 normal;
layout(location = 3) in vec3 tangent;
layout(location = 4) in vec3 bitangent;
layout(location = 5) in vec2 uv;

out vec4 vWorldPos;
out vec4 vColor;
out vec3 vNormal;
out vec2 vUv;

void main() {
	vec4 pos4 = vec4(pos, 1.0);
	mat3 model3 = mat3(modelMatrix);
	
	vWorldPos = modelMatrix * pos4;
	vColor = vec4(color, 1.0);

	vNormal = normalize(model3 * normal);

	gl_Position = VP * vWorldPos;
}