#version 330

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

uniform mat4 VP;
uniform vec3 cameraPos;
uniform float gBillboardSize;

in vec2 coords[];
in float age_vert[];

out vec2 TexCoord;

void main()
{
    vec3 Pos = gl_in[0].gl_Position.xyz;
    float size = gBillboardSize + (age_vert[0]/7500);
	//gCurrentFrame = vCurrentFrame[0];
    vec3 toCamera = normalize(cameraPos - Pos);
    vec3 up = vec3(0.0, 1.0, 0.0);
    vec3 left = cross(toCamera, up);
	up = cross(left, toCamera) * size*2.0;
	left *= size;

    Pos += 0.5*left;
	Pos += 0.5*up;
    gl_Position = VP * vec4(Pos, 1.0);
    TexCoord = coords[0] + vec2(0.0, 0.0);

    EmitVertex();

    Pos -= up;
    gl_Position = VP * vec4(Pos, 1.0);
    TexCoord = coords[0] + vec2(0.0, 0.2);
    EmitVertex();

    Pos += up;
    Pos -= left;
    gl_Position = VP * vec4(Pos, 1.0);
    TexCoord = coords[0] + vec2(0.1, 0.0);
    EmitVertex();

    Pos -= up;
    gl_Position = VP * vec4(Pos, 1.0);
    TexCoord = coords[0] + vec2( 0.1,0.2);
    EmitVertex();

    EndPrimitive();
}
