#version 330                                                                        
                                                                                    
layout (location = 0) in float Type;                                                
layout (location = 1) in vec3 Position;                                             
layout (location = 2) in vec3 Velocity;                                             
layout (location = 3) in float Age; 

uniform mat4 modelMatrix; 
uniform mat4 V;  
uniform float time;

out vec2 coords;    
out float age_vert;                

vec2 getCurrentFrame(int frame) {
	int col = frame % 10;
	int row = (frame - col) / 10;

	return vec2(0.1*col,(0.2*row));
}
                                                                                    
void main()                                                                         
{                    
	int frame = int(Age/time)%50;

    coords = getCurrentFrame(frame);
    age_vert = Age;
	gl_Position = modelMatrix * vec4(Position, 1.0);
}

