#version 330

layout(points) in;
layout(points) out;
layout(max_vertices = 30) out;

in float Type0[];
in vec3 Position0[];
in vec3 Velocity0[];
in float Age0[];

out float Type1;
out vec3 Position1;
out vec3 Velocity1;
out float Age1;

uniform float gDeltaTimeMillis;
uniform float gTime;
uniform float gRandom;
uniform sampler1D gRandomTexture;
uniform float gLauncherLifetime;
uniform float gShellLifetime;
uniform float gSecondaryShellLifetime;

#define PARTICLE_TYPE_LAUNCHER 0.0f
#define PARTICLE_TYPE_SHELL 1.0f

vec3 GetRandomDir(float TexCoord)
{
	 vec3 Dir = texture(gRandomTexture, TexCoord).xyz;
	 //Dir -= vec3(0.5, 0.5, 0.5);
	 Dir = Dir * 2.0 - 1.0;
	 return Dir;
}

void main()
{
	float Age = Age0[0] + gDeltaTimeMillis;
	float DeltaTimeSecs = gDeltaTimeMillis / 1000.0f;
	vec3 Dir = GetRandomDir(gRandom);
	

	if (Type0[0] == PARTICLE_TYPE_LAUNCHER) {
		if (gTime <= 500000) {
			if (Age >= 500.0) {
				Type1 = PARTICLE_TYPE_SHELL;
				Velocity1 = vec3(0.0,0.3,0.0);//normalize(Dir) / 20.0;
				vec3 DeltaP = DeltaTimeSecs * Velocity1;
				Position1 = Position0[0] + DeltaP + 0.004 * Dir;
				Age1 = Age;
				EmitVertex();
				EndPrimitive();
				Age = 0.0;
			}

			Type1 = PARTICLE_TYPE_LAUNCHER;
			Position1 = Position0[0];
			Velocity1 = Velocity0[0];
			Age1 = Age;
			EmitVertex();
			EndPrimitive();
		}
	}
	else {
		float DeltaTimeSecs = gDeltaTimeMillis / 1000.0f;
		vec3 DeltaP = DeltaTimeSecs * Velocity0[0];

		if (Type0[0] == PARTICLE_TYPE_SHELL)  {
			
			if(Age < 7500){
				Type1 = PARTICLE_TYPE_SHELL;
				vec3 DeltaP = DeltaTimeSecs * Velocity0[0];
				Position1 = Position0[0] + DeltaP + 0.004 * Dir;
				Velocity1 = Velocity0[0];
				Age1 = Age;
				EmitVertex();
				EndPrimitive();			
			}

		}
	}
}
